# $Id$
#
# 6ga-common.pl
#
#	Common Perl include file
#

#============================================================
# Forward declaration of config parameters
#============================================================
##our $DOCROOTDIR;
##our $VIDEOROOTDIR;
##our $CONFIGROOTDIR;
##our $MINFREESPACE;
##our $DOCBASEURI;
##our $CHANNELMAP;
##our $FREQUENCYMAP;
##our $KEEPSTALESCHEDINHOURS;
##our $PROJECTAHEADINDAYS;
##our $NUMVIDEODEVICES;
##our $VIDEODEVICE;
##our $RECCOMMANDDELAY;
##our $PRERECCOMMAND;
##our $RECCOMMAND;
##our $POSTRECCOMMAND;

if (!defined($configfile)) {
	my $GCONFIGFILE	= '/usr/local/etc/6ga.conf';
	if ( -f $GCONFIGFILE) {
		readConfigFile($GCONFIGFILE);
		$configfile	= $CONFIGFILE;
	}
}

#============================================================
# Read in cofiguration file
#============================================================
sub readConfigFile {
	my ($configfile)	= @_;
	(defined $configfile)	|| die "no config file\n";

	open(CONFIG, $configfile)	|| die "can't open $configfile\n";
	while (<CONFIG>) {
		chomp;
		eval;
	}
	close CONFIG;
}

readConfigFile($configfile);


#===========================================================
# Return iEPG into passed hash reference
#===========================================================
sub readiEPG {
	my ($path, $iepgref)	= @_;
	unless (open FILE, "$path") {
		return 0;
	}
	while (<FILE>) {
		chomp;
		s/\s+$//;
		last if (/^\s*$/);
		my ($key, $value)	= split /:\s*/, $_, 2;

		unless (defined($value)) {
			logit("Undefined value for header $key:");
			$value	= '';
		}

		$value	=~ s/\\'/'/g;

		# Remove [XX] markings (shift-jis only)
		if ($key eq 'program-title') {
			$value =~ s/\[[\x81-\x9F\xE0-\xFC][@-\x7E\x80-\xFC]\]//g;
		}

		$$iepgref{$key}	= $value;
	}

	until (eof FILE) {
		$$iepgref{'iepg-body'} .= <FILE>;
		$$iepgref{'iepg-body'} =~ s/\n/\\n/g;
	}
	close FILE;
	return 1;
}

#============================================================
# Check if a valid file 6ga file name
#============================================================
sub goodfname {
	my ($name, $suffix, $fncref)	= @_;
	unless ($suffix) {
		$suffix	= '\w+';
	}
	if ($name =~ /^(\d{12})-(\d{3})-(\d{4})-([[:xdigit:]]{8})\.($suffix)$/) {
		if (defined($fncref)) {
			$fncref->{datetime}	= $1;
			$fncref->{channel}	= $2;
			$fncref->{duration}	= $3;
			$fncref->{signature}= $4;
			$fncref->{suffix}	= $5;
		}
		return "$1-$2-$3-$4";
	}
	return undef;
}

