<?php
// $Id: 6ga.php,v 1.2 2014/04/28 16:09:37 name Exp $
//
// 6ga.php - tab display
//
//	Copyright (c) 2005-2012 Hiro Sugawara
//	Licensed under terms of GPL 2.0
//
include('6ga-common.inc');

//
// Global settings
//

$MYURI	= $_SERVER['PHP_SELF'];
$loadOthers	= @$_GET['noload'] ? "" : " onLoad=\"loadOthers()\"";

if (is_null($thistab)) {
	$thistab = 'scheduled';
}
setcookie('tab', $thistab);

//
// Tab parameters
//
$TABTEXT	= array('scheduled'	=> 'Scheduled',
					'recorded'	=> 'Recorded',
					'regular'	=> 'Regular');
$NUMTABS	= count($TABS);
$TABWIDTH	= sprintf("%d%%", 100/$NUMTABS);

function showTab($what) {
	global $MYURI, $TABWIDTH, $TABCOLOR, $TABTEXT;
	global $thistab;

	$anchor	= '';
	$anchorClose	= '';
	if ($what != $thistab) {
		$anchor	= sprintf("<A HREF='%s?tab=%s' onClick=\"loadOthers('%s');\">",
						$MYURI, $what, $what);
		$anchorClose	= '</A>';
	}

	printf("\t<TD WIDTH='%s' BGCOLOR='%s'>", $TABWIDTH, $TABCOLOR[$what]);
	printf("<CENTER>%s<B>%s</B>%s</CENTER>",
								$anchor, $TABTEXT[$what], $anchorClose);
	printf("</TD>\n");
}

//
// Common utilities
//
function getFreeDiskSpace() {
	global $VIDEOROOTDIR;
	
	$unit	= 'G';
	$handle	= popen("df -B $unit $VIDEOROOTDIR|tail -1|awk '{print \$(NF-2)}'",
					"r");
	$dfOut	= fread($handle, 500);
	pclose($handle);
	$dfOut	= trim($dfOut);
	// Old df versions may not have trailing unit
	if (substr($dfOut, -1) != $unit)
		$dfOut	.= $unit;
	return $dfOut . 'B';
}

function getUptime() {
	$handle = popen("uptime | awk '{ print $3, $4 }'", "r");
	$uptime = fread($handle, 500);
	pclose($handle);
	return $uptime;
}

//
// Set up global JavaScript variables
//
$PANELURI = sprintf("6ga-panel.php?tab=$thistab&_time=%d", time());
foreach (array_keys($_GET) as $key) {
	$PANELURI	.= sprintf("&$key=%s", urlencode($_GET[$key]));
}

$LISTURI = sprintf("6ga-list.php?tab=$thistab&_time=%d", time());

printDocHeader();
echo <<<_EOS
<META HTTP-EQUIV='Refresh' CONTENT='900'>
<HTML>
<HEAD>
<STYLE TYPE="text/css">
<!--
A {text-decoration:none}
A:anchor {
	color: #000000;
}
A:visted {
	color: #c0c0c0;
}
A:hover {
	color: #ff3f00;
}
-->
</STYLE>
<SCRIPT LANGUAGE='JavaScript'>
<!--
var paneluri	= '$PANELURI';
var listuri		= '$LISTURI';

function loadOthers() {
	window.open(paneluri, '_6ga_panel');
	window.open(listuri, '_6ga_list');
}
//-->
</SCRIPT>
</HEAD>
<BODY BGCOLOR='#000070'$loadOthers>
<CENTER>
<TABLE WIDTH='100%' HEIGHT=120 BORDER=0 CELLSPACING=0>
<TR HEIGHT=18>
_EOS;

//
// Show all tab headers
//
foreach ($TABS as $tab) {
	showTab($tab);
}

echo <<<_EOS
</TR>
<TR VALIGN='top'>
_EOS;

$freeSpace	= getFreeDiskSpace();
$uptime	= getUptime();
//
// Show body base with tab color
//
printf("<TD COLSPAN=%d BGCOLOR=%s>\n", $NUMTABS, $TABCOLOR[$thistab]);
echo <<<_EOS
	<TABLE WIDTH='100%' BORDER=0 CELLSPACING=0 CELLPADDING=1>
	<TR HEIGHT=40><TD>
		<TABLE WIDTH='100%' BORDER=0>
		<TR><TD BGCOLOR='#ffffff'><CENTER><B>
		Up $uptime Free Disk Space: $freeSpace
		</B></CENTER>
		</TD></TR>
		</TABLE>
	</TD></TR>
	</TABLE>
</TD></TR>
</TABLE>
</CENTER>
</BODY>
</HTML>
_EOS;
?>
