#!/usr/bin/perl -w
# $Header$
#
# addtitle.pl
#

use strict;
use File::Basename;

my @times = (
	'1940',		# Miru rekishi
	'0745',		# TV ehon
	'1030',		# Kodomo ninngyou gekijo
	'1030',		# Kodomo ninngyou gekijo
	'1800',		# Sanjushi
);

my $commdir	= '/var/mm/video/comments';
my @progs;
my $myname	= basename($0);
my $date	= '????????';

sub usage {
	print STDERR "Usage: $myname [hhmm [yyyymmdd]]\n";
	print STDERR "Default hhmm's: @times\n";
}

if ($ARGV[0]) {
	if ($ARGV[0] =~ /^[012]\d[0-5]\d$/) {
		@times	= shift @ARGV;
		if ($ARGV[0] =~ /^20[0-2]\d[01]\d[0-3]\d$/) {
			$date	= shift @ARGV;
		}
	} else {
		usage();
		exit 1;
	}
}

# Get list of programs
foreach my $time (@times) {
	push @progs,
		`cd $commdir && ls -r $date$time?.txt 2>/dev/null | head -40`;
}

if ($#progs < 0) {
	print "No programs\n";
	exit 0;
}

# Show title of each program
my $count	= 0;
foreach my $prog (@progs) {
	my $title	= `head -1 $commdir/$prog`;
	chomp $title;
	chomp $title;
	chomp $title;
	printf "%2d: %s/%s/%s %s:%s %s",
		++$count,
		substr($prog, 0, 4), substr($prog, 4, 2), substr($prog, 6, 2),
		substr($prog, 8, 2), substr($prog, 10, 2),
		`echo '$title' | iconv -f shift-jis -t utf-8`;
}

# Prompt for which program
my $choice = 0;
if ($count > 1) {
	printf STDERR "Which (1-%d)? ", $count;
	$choice	= <STDIN>;
	chomp $choice;
	if ($choice !~ /^\d+$/ || $choice > $count || --$choice < 0) {
		printf "Bad choice.\n";
		exit 0;
	}
}
printf STDERR "Append (a) or replace (r)? ";
my $op	= <STDIN>;
chomp $op;
if ($op ne 'a' && $op ne 'r') {
	printf "Bad operation.\n";
	exit 0;
}

# Prompt for text to append or replace with
printf STDERR "Enter text to %s: ", ($op eq 'a') ? 'append' : 'replace with';
my $text	= <STDIN>;
chomp $text;

# Read selected program's text lines
open COMM, "$commdir/$progs[$choice]"
	|| die "Can't open $commdir/$progs[$choice] for reading.\n";
my @lines	= <COMM>;
close COMM;
chomp @lines;

my $line0	= $lines[0];
$line0	=~ s/\"/\\"/g;
$line0	=~ s/\`/\\`/g;
my $line1	= `echo "$line0" | iconv -f shift-jis -t utf-8`;
chomp $line1;
if ($op eq 'a') {# Append wide-space and text
	$line1	.= sprintf "%c%c%c%s", 0xe3, 0x80, 0x80, $text;
} else {
	$line1	= $text;
}
$lines[0] = `echo "$line1" | iconv -f utf-8 -t shift-jis`;

open COMM, ">$commdir/$progs[$choice]"
	|| die "Can't open $commdir/$progs[$choice] for writing.\n";
foreach my $line (@lines) {
	print COMM "$line\n";
}
close COMM;

0;
