<?php
// $Header$
//
// stream-index.php
//
//	Portal for PC based real-time TV streaming.
//	Copyright (c) 2012 Hiro Sugawara
//
?>
<HTML>
<META HTTP-EQUIV='Content-Type' CONTENT='text/html;charset=UTF-8'>
<HEAD>
<TITLE>
地上ディジタル放送ライブ・ストリーミング
</TITLE>
</HEAD>
<?php
$tzmins	= 9 * 60;	// JST default

$script_name = $_SERVER['SCRIPT_FILENAME'];
$output = array();
exec("sed 's|#.*$||' " .(dirname($script_name) . "/tv-dl.conf"), $output);
foreach ($output as $line) {
	eval($line);
}

//
// Retrieve cookies
//
$channel_cookie	= @$_COOKIE['tv_live_stream_channel'];
$size_cookie	= @$_COOKIE['tv_live_stream_size'];
$bitrate_cookie	= @$_COOKIE['tv_live_stream_bitrate'];

//
// Get channel list dynamically from the recording server.
//
$channelOptions = array();
$channels = array();
$channelURL = preg_replace('/\\\\@/', '@', $CHANNELURL);

// Embedded URL open cannot handle username/password
if (($fp = popen("elinks -no-home -source \"$channelURL\"", 'r'))) {
	$matches = array();
	while (($line = trim(fgets($fp)))) {
		if (preg_match('/^(\d+):\s*(.*)$/', $line, $matches)) {
			$channelOptions[$matches[2]] = $matches[1];
		} else if (preg_match('/^tz:\s*(.*)$/i', $line, $matches)) {
			$tzmins = substr($matches[1], 0, -2) * 60 + substr($matches[1], -2);
		}
	}
	pclose($fp);
}

$sizeOptions = array(
	'1920x1080'	=> '1920x1080',
	'1280x720'	=> '1280x720',
	'960x540'	=> '960x540',
	'720x405'	=> '720x405',
	'640x360'	=> '640x360',
	'480x270'	=> '480x270',
	'320x180'	=> '320x180',
);

$bitrateOptions = array(
	"18Mbps"	=>"18000000",
	"8Mbps"		=>"8000000",
	"6Mbps"		=>"6000000",
	"4Mbps"		=>"4000000",
	"2Mbps"		=>"2000000",
	"1Mbps"		=>"1000000",
	"500kbps"	=>"500000",
);

function selectOptions($options, $selected) {
	foreach (array_keys($options) as $option) {
		printf("<OPTION VALUE=\"%s\"%s>%s</OPTION>\n",
				$options[$option],
				($options[$option] == $selected) ?  " SELECTED" : "",
				$option);
	}
}
?>

<SCRIPT LANGUAGE='JavaScript'>
<!--
//
// real-time clock code from http://tycho.usno.navy.mil/rc.html
//
<?php
echo "var tzmins	= $tzmins;\n";
?>
var DOW		= new Array('日曜日', '月曜日', '火曜日', '水曜日',
						'木曜日', '金曜日', '土曜日');

var station = 'unknown';

var tick;
function stop() {
 	clearTimeout(tick);
}

function simpleClock() {
	var ct = new Date();
	var ut = ct.getTime() + ct.getTimezoneOffset() * 60 * 1000;
	var jst = new Date(ut + tzmins * 60 * 1000);
	var y, M, d, D, h, m, s;
	var date, time;
	y	= jst.getYear();
	M	= jst.getMonth() + 1;
	d	= jst.getDate();
	D	= jst.getDay();
	h	= jst.getHours();
	m	= jst.getMinutes();
	s	= jst.getSeconds();
	if (y < 2000) y += 1900;
	if (M <= 9) M = '0' + M;
	if (d <= 9) d = '0' + d;
	if (s <= 9) s = '0' + s;
	if (m <= 9) m = '0' + m;
	if (h <= 9) h = '0' + h;
	date = y + '/' + M + '/' + d;
	time = h + ':' + m + ':' + s;

	document.getElementById('time').innerHTML	= time;
	document.getElementById('date').innerHTML	= date;
	document.getElementById('dow').innerHTML	= DOW[D];
	tick	= setTimeout('simpleClock()', 1000);   
}

//
// Update iFrame caption (station name, size, bit rate)
//
function updateStation() {
	document.getElementById('tuned').innerHTML = '<B>' +
		document.getElementById('channel').options[document.getElementById('channel').selectedIndex].text + '</B> ' +
		'<FONT SIZE="-2">' +
		document.getElementById('size').options[document.getElementById('size').selectedIndex].text + ' ' +
		document.getElementById('bitrate').options[document.getElementById('bitrate').selectedIndex].text +
		'</FONT>';

	SFRAME.location.href = "spinner.gif";
	simpleClock();
}

//
// Update iFrame size
//
function updateIframe() {
	var iframe	= document.getElementById('SFRAME');
	var size	= document.getElementById('size').options[document.getElementById('size').selectedIndex].text;
	var wxh	= size.split('x');
	
	iframe.width	= wxh[0] + 'px';
	iframe.height	= wxh[1] + 'px';
}

function updateAll() {
	updateStation();
	updateIframe();
}
//-->
</SCRIPT>

<BODY onLoad='simpleClock();'>
<TABLE WIDTH="100%">
  <TR><TD COLSPAN=2>
<?php
if (strpos($_SERVER['HTTP_USER_AGENT'], 'GoogleTV') != FALSE) {
	$target = "";
} else {
	$target = "TARGET=\"SFRAME\"";
}
  printf("<FORM NAME=\"tune\" METHOD=\"GET\"ACTION=\"stream.php\" %s>\n",
  		$target);
?>
  <TABLE WIDTH="100%" CELLSPACING=0>
    <TR BGCOLOR="#0000c0" VALIGN="bottom">
      <TD><FONT SIZE="+3" COLOR="white">
地上ディジタル放送ライブ・ストリーミング
      </FONT></TD>
      <TD><FONT COLOR="white">
	  <SPAN ID='date'>date</SPAN>
	  <SPAN ID='dow'>dow</SPAN>
	  <SPAN ID='time'>time</SPAN> JST
      </FONT></TD>
      <TD><FONT COLOR="white">
	    Station: </FONT>
	    <SELECT NAME="channel" ID="channel">
<?php
	selectOptions($channelOptions, $channel_cookie);
?>
	    </SELECT>
	  </TD>
      <TD><FONT COLOR="white">
	    Size: </FONT>
	    <SELECT NAME="size" ID="size">
<?php
	selectOptions($sizeOptions, $size_cookie);
?>
	    </SELECT>
	  </TD>
      <TD><FONT COLOR="white">
	    Bit rate: </FONT>
	    <SELECT NAME="bitrate" ID="bitrate">
<?php
	selectOptions($bitrateOptions, $bitrate_cookie);
?>
	    </SELECT>
	  </TD>
	  <TD>
	    <INPUT TYPE="SUBMIT" VALUE="Tune" onClick="updateAll();">
	  </TD>
    </TR>
  </TABLE>
  </FORM ></TD></TR>

  <TR><TD>
    <TABLE WITH="320"><TR><TD>
      <IFRAME NAME="SFRAME" ID="SFRAME" WIDTH="320px" HEIGHT="180px"></IFRAME>
      </TD></TR>
      <TR><TD ALIGN="center"><B>
	  視聴中:
	  </B>
	  <SPAN ID="tuned"></SPAN>
	</TD></TR></TABLE>
  </TD>

  <TD VALIGN="top" WIDTH="100%">
    <TABLE WIDTH="100%"><TR>
<?php
if (0) {
	foreach (array_keys($channelOptions) as $channel) {
		printf("<TD ALIGN=\"center\" BGCOLOR=\"blue\" WIDTH=\"%d%%\">\n",
				100/count($channelOptions));
		printf("<FONT COLOR=\"white\"><B>%s</B></FONT>\n", $channel);
		echo "</TD>\n";
	}
	echo "</TR><TR>\n";
	foreach (array_keys($channelOptions) as $channel) {
		echo "<TR><TD><TABLE><TR><TD>\n";
		printf("<SPAN ID=\"start_%d\"></SPAN>\n", $channelOptions[$channel]);
		echo "</TD></TR><TR><TD>\n";
		printf("<SPAN ID=\"title_%d\"></SPAN>\n", $channelOptions[$channel]);
		echo "</TD></TR></TABLE></TD>\n";
	}
}
?>
	</TR></TABLE>
  </TD>
  </TR>
</TABLE>
</BODY>
</HTML>
